import java.util.*;
import java.io.*;

public class C {
	
	int W, H;
	
	int DX[] = { 0, 1, 0,-1};
	int DY[] = { 1, 0,-1, 0};
	
	int markIt(boolean map[][], boolean visited[][], int IDs[][], int y, int x, int id, boolean val) {
		LinkedList<Integer> qx = new LinkedList<Integer>();
		LinkedList<Integer> qy = new LinkedList<Integer>();
		
		visited[y][x] = true;
		IDs[y][x] = id;
		qx.add(x);
		qy.add(y);
		
		int neighborID = -1;
		while(qx.size()>0) {
			int cx = qx.removeFirst();
			int cy = qy.removeFirst();
			
			for(int di=0;di<4;di++) {
				int nx = cx + DX[di];
				int ny = cy + DY[di];
				
				if(nx<0 || ny<0 || nx>=W*4 || ny>=H) continue;
				if(map[ny][nx]!=val) {
					if(IDs[ny][nx]!=id) {
						neighborID = IDs[ny][nx];
					}
					continue;
				}
				if(visited[ny][nx]) continue;

				visited[ny][nx] = true;
				IDs[ny][nx] = id;
				
				qx.add(nx);
				qy.add(ny);
			}
		}
		
		return neighborID;
	}
	
	void doIt() {
		Scanner sc = new Scanner(System.in);
		PrintStream ps = System.out;
		
		int IDs[][] = new int[200][200];
		boolean map[][] = new boolean[200][200];
		boolean visited[][] = new boolean[200][200];
		
		for(int testno=1;;testno++) {
			H = sc.nextInt();
			W = sc.nextInt();
			
			if(H==0 || W==0) break;
			
			for(int i=0;i<H;i++) for(int j=0;j<W*4;j++) map[i][j] = false;
			for(int i=0;i<H;i++) for(int j=0;j<W*4;j++) visited[i][j] = false;
			for(int i=0;i<H;i++) for(int j=0;j<W*4;j++) IDs[i][j] = -1;

			for(int i=0;i<H;i++) {
				String s = sc.next().toUpperCase();
				for(int j=0;j<W;j++) {
					char c = s.charAt(j);
					int v = "0123456789ABCDEF".indexOf(c);
					
					for(int k0=3,k1=0;k0>=0;k0--,k1++) {
						if(((1<<k0) & v)==0) {
							map[i][j*4 + k1] = false;
						}
						else {
							map[i][j*4 + k1] = true;
						}
					}
				}
			}
			
			//mark the connected regions first
			int id = 0;
			for(int i=0;i<H;i++) for(int j=0;j<W*4;j++) {
				if(map[i][j] && !visited[i][j]) {
					markIt(map, visited, IDs, i, j, id, map[i][j]);
					id++;
//					printMap(IDs, visited);
				}
			}
			
			//mark the outside regions
			for(int i=0;i<H;i++) {
				if(!map[i][0] && !visited[i][0]) {
					markIt(map, visited, IDs, i, 0, -1, map[i][0]);
				}
				if(!map[i][W*4-1] && !visited[i][W*4-1]) {
					markIt(map, visited, IDs, i, W*4-1, -1, map[i][W*4-1]);
				}
			}
			for(int i=0;i<W*4;i++) {
				if(!map[0][i] && !visited[0][i]) {
					markIt(map, visited, IDs, 0, i, -1, map[0][i]);
				}
				if(!map[H-1][i] && !visited[H-1][i]) {
					markIt(map, visited, IDs, H-1, i, -1, map[H-1][i]);
				}
			}
			
//			System.out.printf("id=%d\n", id);
			int vals[] = new int[id];
			Arrays.fill(vals, 0);
			for(int i=0;i<H;i++) for(int j=0;j<W*4;j++) {
				if(!map[i][j] && !visited[i][j]) {
					int neighbor_id = markIt(map, visited, IDs, i, j, -1, map[i][j]);
					if(neighbor_id==-1) {
						System.out.printf("impossible\n");
					}
					vals[neighbor_id]++;
				}
			}
			char cs[] = new char[id];
			for(int i=0;i<id;i++) {
				cs[i] = "WAKJSD".charAt(vals[i]);
			}
			Arrays.sort(cs);
			
			ps.printf("Case %d: %s\n", testno, new String(cs));
		}
	}
	
	void printMap(int IDs[][], boolean visited[][]) {
		for(int i=0;i<visited.length;i++) {
			for(int j=0;j<visited[i].length;j++) {
				System.out.printf("%d", IDs[i][j]+1);
			}
			System.out.println();
		}
	}
	
	public static void main(String args[]) {
		(new C()).doIt();
	}
}
 